/*
 * VCNL36826S_Prototypes.h
 *
 * Created  : 13 April 2021
 * Modified : 6 May 2021
 * Author   : HWanyusof
 * Version	: 1.0
 */

#include "typedefinition.h"


/*Turn the PS Sensor On/Off
 *VCNL36826S_SET_PS_ON(Byte ps_on)
 *Byte ps_on - Input Parameter:
 *
 * VCNL36826S_PS_ON_EN
 * VCNL36826S_PS_ON_DIS
 */
void VCNL36826S_SET_PS_ON(Byte ps_on);

/*Set the PS_CAL bit for initialization
 *VCNL36826S_SET_PS_CAL(Byte ps_cal)
 *Byte ps_cal - Input Parameter:
 *
 * VCNL36826S_PS_CAL_EN
 * VCNL36826S_PS_CAL_DIS
 */
void VCNL36826S_SET_PS_CAL(Byte ps_cal);

/*Set the PS_ST bit for initialization
 *VCNL36826S_SET_PS_ST(Byte ps_st)
 *Byte ps_st - Input Parameter:
 *
 * VCNL36826S_PS_ST_START
 * VCNL36826S_PS_ST_STOP
 */
void VCNL36826S_SET_PS_ST(Byte ps_st);

/*Set the PS measurement period
 *VCNL36826S_SET_PS_PERIOD(Byte ps_period)
 *Byte ps_period - Input Parameter:
 *
 * VCNL36826S_PS_PERIOD_10ms
 * VCNL36826S_PS_PERIOD_20ms
 * VCNL36826S_PS_PERIOD_40ms
 * VCNL36826S_PS_PERIOD_80ms
 */
void VCNL36826S_SET_PS_PERIOD(Byte ps_period);

/*Set the Persistence
 *VCNL36826S_SET_PS_PERS(Byte ps_pers)
 *Byte ps_pers - Input Parameter:
 *
 * VCNL36826S_PS_PERS_1
 * VCNL36826S_PS_PERS_2
 * VCNL36826S_PS_PERS_3
 * VCNL36826S_PS_PERS_4
 */
void VCNL36826S_SET_PS_PERS(Byte ps_pers);

/*Set the Interrupt Mode
 *VCNL36826S_SET_PS_INT(Byte ps_int)
 *Byte ps_int - Input Parameter:
 *
 * VCNL36826S_PS_INT_DIS
 * VCNL36826S_PS_INT_LOGIC
 * VCNL36826S_PS_INT_FIRST_HIGH
 * VCNL36826S_PS_INT_EN
 */
void VCNL36826S_SET_PS_INT(Byte ps_int);

/*Enable/Disable Smart Persistence
 *VCNL36826S_SET_PS_SMART_PERS(Byte Pers)
 *Byte Pers - Input Parameter:
 *
 * VCNL36826S_PS_SMART_PERS_EN
 * VCNL36826S_PS_SMART_PERS_DIS
 */
void VCNL36826S_SET_PS_SMART_PERS(Byte Pers);

/*Set the Integration Time
 *VCNL36826S_SET_PS_IT(Byte IntegrationTime)
 *Byte IntegrationTime - Input Parameter:
 *
 * VCNL36826S_PS_IT_1T
 * VCNL36826S_PS_IT_2T
 * VCNL36826S_PS_IT_4T
 * VCNL36826S_PS_IT_8T
 */
void VCNL36826S_SET_PS_IT(Byte IntegrationTime);

/*Set the Multi Pulse (MPS) setting
 *VCNL36826S_SET_PS_MPS(Byte ps_mps)
 *Byte ps_mps - Input Parameter:
 *
 * VCNL36826S_PS_MPS_1
 * VCNL36826S_PS_MPS_2
 * VCNL36826S_PS_MPS_4
 * VCNL36826S_PS_MPS_8
 */
void VCNL36826S_SET_PS_MPS(Byte ps_mps);

/*Set the Integration Time Bank (Pulse Width)
 *VCNL36826S_SET_PS_ITB(Byte ps_itb)
 *Byte ps_itb - Input Parameter:
 *
 * VCNL36826S_PS_ITB_25
 * VCNL36826S_PS_ITB_50
 */
void VCNL36826S_SET_PS_ITB(Byte ps_itb);

/*Enable/Disable High Gain setting
 *VCNL36826S_SET_PS_HG(Byte ps_hg)
 *Byte ps_hg - Input Parameter:
 *
 * VCNL36826S_PS_HG_DIS
 * VCNL36826S_PS_HG_EN
 */
void VCNL36826S_SET_PS_HG(Byte ps_hg);

/*Set the Sensor Mode (Active Force or Auto Mode)
 *VCNL36826S_SET_PS_AF(Byte ps_af)
 *Byte ps_af - Input Parameter:
 *
 * VCNL36826S_PS_AF_EN
 * VCNL36826S_PS_AUTO
 */
void VCNL36826S_SET_PS_AF(Byte ps_af);

/*Enable/Disable Trigger for AF Mode
 *VCNL36826S_SET_PS_TRIG(Byte TriggerBit)
 *Byte TriggerBit - Input Parameter:
 *
 * VCNL36826S_PS_TRIG_EN
 * VCNL36826S_PS_TRIG_DIS
 */
void VCNL36826S_SET_PS_TRIG(Byte TriggerBit);

/*Set the detect cycle after trigger
 *VCNL36826S_SET_PS_FORCENUM(Byte ps_forcenum)
 *Byte ps_forcenum - Input Parameter:
 *
 * VCNL36826S_PS_FORCENUM_1
 * VCNL36826S_PS_FORCENUM_2
 */
void VCNL36826S_SET_PS_FORCENUM(Byte ps_forcenum);

/*Set the Sunlight Protect
 *void VCNL36826S_SET_PS_SP_INT(Byte ps_sp_int)
 *Byte ps_sp_int - Input Parameter:
 *
 * VCNL36826S_PS_SP_INT_DIS
 * VCNL36826S_PS_SP_INT_EN
 */
void VCNL36826S_SET_PS_SP_INT(Byte ps_sp_int);

/*Enable/Disable the sunlight cancellation
 *VCNL36826S_SET_PS_SC(Byte ps_sc)
 *Byte ps_sc - Input Parameter:
 *
 * VCNL36826S_PS_SC_EN
 * VCNL36826S_PS_SC_DIS
 */
void VCNL36826S_SET_PS_SC(Byte ps_sc);

/*Set the Sensor output Bit Size
 *VCNL36826S_SET_PS_HD(Byte ps_hd)
 *Byte ps_hd - Input Parameter:
 *
 * VCNL36826S_PS_HD_12Bits
 * VCNL36826S_PS_HD_16Bits
 */
void VCNL36826S_SET_PS_HD(Byte ps_hd);

/*Set the VCSEL current
 *VCNL36826S_SET_I_VCSEL(Byte i_vcsel)
 *Byte i_vcsel - Input Parameter:
 *
 * VCNL36826S_I_VCSEL_6mA
 * VCNL36826S_I_VCSEL_8mA
 * VCNL36826S_I_VCSEL_10mA
 * VCNL36826S_I_VCSEL_12mA
 * VCNL36826S_I_VCSEL_14mA
 * VCNL36826S_I_VCSEL_16mA
 * VCNL36826S_I_VCSEL_18mA
 * VCNL36826S_I_VCSEL_20mA
 */
void VCNL36826S_SET_I_VCSEL(Byte i_vcsel);

/*Set the Low Threshold
 *VCNL36826S_SET_PS_LowThreshold(Word LowThreshold)
 *Word LowThreshold - Input Parameter:
 *
 * Value between 0d0 and 0d4095
 */
void VCNL36826S_SET_PS_LowThreshold(Word LowThreshold);

/*Set the High Threshold
 *VCNL36826S_SET_PS_HighThreshold(Word HighThreshold)
 *Word HighThreshold - Input Parameter:
 *
 * Value between 0d0 and 0d4095
 */
void VCNL36826S_SET_PS_HighThreshold(Word HighThreshold);

/*Set the PS Cancellation
 *VCNL36826S_SET_PS_CANC(Word CancelValue)
 *Word CancelValue - Input Parameter:
 *
 * Value between 0d0 and 0d4095
 */
void VCNL36826S_SET_PS_CANC(Word CancelValue);

/*Enable/Disable PS Auto Calibration
 *VCNL36826S_SET_PS_AC(Byte ps_ac)
 *Byte ps_ac - Input Parameter:
 *
 * VCNL36826S_PS_AC_EN
 * VCNL36826S_PS_AC_DIS
 */
void VCNL36826S_SET_PS_AC(Byte ps_ac);

/*Set the Auto Calibration sample period
 *VCNL36826S_SET_PS_AC_PERIOD(Byte ps_ac_per)
 *Byte ps_ac_per - Input Parameter:
 *
 * VCNL36826S_PS_AC_PERIOD_3ms
 * VCNL36826S_PS_AC_PERIOD_6ms
 * VCNL36826S_PS_AC_PERIOD_12ms
 * VCNL36826S_PS_AC_PERIOD_24ms
 */
void VCNL36826S_SET_PS_AC_PERIOD(Byte ps_ac_per);

/*Set the Auto Calibration sample number
 *VCNL36826S_SET_PS_AC_NUM(Byte ps_ac_num)
 *Byte ps_ac_num - Input Parameter:
 *
 * VCNL36826S_PS_AC_NUM1
 * VCNL36826S_PS_AC_NUM2
 * VCNL36826S_PS_AC_NUM4
 * VCNL36826S_PS_AC_NUM8
 */
void VCNL36826S_SET_PS_AC_NUM(Byte ps_ac_num);

/*Enable/Disable Trigger for Auto Calibration
 *VCNL36826S_SET_PS_AC_TRIG(Byte ps_ac_trig)
 *Byte ps_ac_trig - Input Parameter:
 *
 * VCNL36826S_PS_AC_TRIG_DIS
 * VCNL36826S_PS_AC_TRIG_EN
 */
void VCNL36826S_SET_PS_AC_TRIG(Byte ps_ac_trig);

/*Enable/Disable Auto Calibration Interrupt
 *VCNL36826S_SET_PS_AC_INT(Byte ps_ac_int)
 *Byte ps_ac_int - Input Parameter:
 *
 * VCNL36826S_PS_AC_INT_DIS
 * VCNL36826S_PS_AC_INT_EN
 */
void VCNL36826S_SET_PS_AC_INT(Byte ps_ac_int);

/*Set the detection Period at Low Power Mode
 *VCNL36826S_SET_PS_LPPER(Byte ps_lpper)
 *Byte ps_lpper - Input Parameter:
 *
 * VCNL36826S_PS_LPPER_40ms
 * VCNL36826S_PS_LPPER_80ms
 * VCNL36826S_PS_LPPER_160ms
 * VCNL36826S_PS_LPPER_320ms
 */
void VCNL36826S_SET_PS_LPPER(Byte ps_lpper);

/*Enable/Disable Low Power Mode
 *VCNL36826S_SET_PS_LPEN(Byte ps_lpen)
 *Byte ps_lpen - Input Parameter:
 *
 * VCNL36826S_PS_LPEN_DIS
 * VCNL36826S_PS_LPEN_EN
 */
void VCNL36826S_SET_PS_LPEN(Byte ps_lpen);

/*Read Register value
 *VCNL36826S_READ_Reg(Byte Reg)
 *Byte Reg - Input Parameter:
 *
 * VCNL36826S_PS_CONF1
 * VCNL36826S_PS_CONF2
 * VCNL36826S_PS_CONF3
 * VCNL36826S_PS_THDL
 * VCNL36826S_PS_THDH
 * VCNL36826S_PS_CANC
 * VCNL36826S_PS_CONF4
 * VCNL36826S_PS_DATA
 * VCNL36826S_PS_INT_FLAG
 * VCNL36826S_PS_ID
 * VCNL36826S_PS_AC_DATA
 *
 *returns Register Value between 0d0/0x00 and 0d65535/0xFFFF
 *except for VCNL36826S_PS_THDH, VCNL36826S_PS_THDL & VCNL36826S_PS_CANC
 */
Word VCNL36826S_READ_Reg(Byte Reg);

/*Read Proximity Data
 *VCNL36826S_GET_PS_DATA()
 *
 *returns PS Data between 0d0 and 0d65535
 */
Word VCNL36826S_GET_PS_DATA();

/*Read the PS Interruppt Flag
 *VCNL36826S_GET_PS_INT_FLAG() returns interrupt flag status.
 *Please refer to Table 13 in the Datasheet page 11
 */
Word VCNL36826S_GET_PS_INT_FLAG();

/*Read the PS Interruppt Flag for auto calibration
 *VCNL36826S_GET_PS_AC_INT_FLAG() returns interrupt flag status.
 *Please refer to Table 13 in the Datasheet page 11
 */
Word VCNL36826S_GET_PS_AC_INT_FLAG();

/*Read Device ID
 *Returns ID
 */
Word VCNL36826S_GET_ID();

/*Read Auto Calibration Data
 *VCNL36826S_GET_PS_AC_DATA()
 *
 *returns PS Data between 0d0 and 0d4095
 */
Word VCNL36826S_GET_PS_AC_DATA();

/*Read Auto Calibration Data Status
 *VCNL36826S_GET_PS_AC_DATA_STATUS()
 *
 *returns 0x80 when AC_BUSY, 0x40 PS enters sunlight protect during auto-calibration
 */
Byte VCNL36826S_GET_PS_AC_DATA_STATUS();

/*Read the PS_ON bit
*returns 1 for Shutdown and 0 for Sensor On
*/
bool VCNL36826S_GET_PS_ON_Bit();

/*Read the PS_AF bit
 *returns 1 for AF Mode and 0 for Auto Mode
 */
bool VCNL36826S_GET_PS_AF_Bit();

/*Read the PS_AC bit
 *returns 1 for Auto Calibration Mode and 0 for Normal Mode
 */
bool VCNL36826S_GET_PS_AC_Bit();

/*Read the PS_AC_PERIOD bit
 *returns:
 * 0 - 3ms
 * 1 - 6ms
 * 2 - 12ms
 * 3 - 24ms
 */
int VCNL36826S_GET_PS_AC_PERIOD_Bit();

/*Read the PS_AC_NUM bit
 *returns:
 * 0 - 1
 * 1 - 2
 * 2 - 4
 * 3 - 8
 */
int VCNL36826S_GET_PS_AC_NUM_Bit();

/*Read the PS_LPEN bit
 *returns 1 for Low Power Mode and 0 for Normal Mode
 */
bool VCNL36826S_GET_PS_LPEN_Bit();


